Package de.willuhn.jameica.hbci.rmi

# Interface BaseDauerauftrag

All Superinterfaces:
  `de.willuhn.datasource.rmi.Changeable`, `Checksum`, `de.willuhn.datasource.rmi.DBObject`, `de.willuhn.datasource.GenericObject`, `HibiscusDBObject`, `HibiscusTransfer`, `Remote`, `de.willuhn.datasource.rmi.Transactionable`, `Transfer`

All Known Subinterfaces:
  `Dauerauftrag`, `SepaDauerauftrag`

All Known Implementing Classes:
  `AbstractBaseDauerauftragImpl`, `DauerauftragImpl`, `SepaDauerauftragImpl`

public interface BaseDauerauftrag extends HibiscusTransfer, Checksum
Basis-Interface fuer Dauerauftraege in Hibiscus.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ORDERID_PLACEHOLDER`
Platzhalter-Order-ID fuer Banken, die bei der Dauerauftrags-Einreichung keine Order-ID liefern.

## Method Summary

Modifier and Type
Method
Description
`void`
`delete()`
Loescht den Dauerauftrag lediglich im lokalen Datenbestand, nicht jedoch bei der Bank.
`Date`
`getErsteZahlung()`
Liefert das Datum der ersten Zahlung.
`Date`
`getLetzteZahlung()`
Liefert das Datum der letzten Zahlung oder `null`, wenn kein Zahlungsende definiert ist.
`Date`
`getNaechsteZahlung()`
BUGZILLA 204 Liefert das voraussichtliche Datum der naechsten Zahlung.
`String`
`getOrderID()`
Liefert die eindeutige ID von der Bank.
`Turnus`
`getTurnus()`
Liefert den Zahlungsturnus fuer diesen Dauerauftrag.
`boolean`
`isActive()`
Liefert `true` wenn der Dauerauftrag bei der Bank aktiv ist.
`void`
`setErsteZahlung(Date datum)`
Legt das Datum fuer die erste Zahlung fest.
`void`
`setLetzteZahlung(Date datum)`
Legt das Datum fuer die letzte Zahlung fest.
`void`
`setOrderID(String id)`
Speichert die Order-ID des Dauerauftrages.
`void`
`setTurnus(Turnus turnus)`
Legt den Zahlungsturnus fest.

### Methods inherited from interface de.willuhn.datasource.rmi.Changeable

`clear, isNewObject, overwrite, store`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.Checksum

`getChecksum`

### Methods inherited from interface de.willuhn.datasource.rmi.DBObject

`addDeleteListener, addStoreListener, equals, getAttribute, getAttributeType, getList, getPrimaryAttribute, load, removeDeleteListener, removeStoreListener`

### Methods inherited from interface de.willuhn.datasource.GenericObject

`getAttributeNames, getID`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.HibiscusDBObject

`getMeta, setMeta`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.HibiscusTransfer

`getKonto, setBetrag, setGegenkonto, setGegenkontoBLZ, setGegenkontoName, setGegenkontoNummer, setKonto, setWeitereVerwendungszwecke, setZweck, setZweck2`

### Methods inherited from interface de.willuhn.datasource.rmi.Transactionable

`transactionBegin, transactionCommit, transactionRollback`

### Methods inherited from interface de.willuhn.jameica.hbci.rmi.Transfer

`getBetrag, getGegenkontoBLZ, getGegenkontoName, getGegenkontoNummer, getWeitereVerwendungszwecke, getZweck, getZweck2`

## Field Details

### ORDERID_PLACEHOLDER

static final String ORDERID_PLACEHOLDER
Platzhalter-Order-ID fuer Banken, die bei der Dauerauftrags-Einreichung keine Order-ID liefern. Dann koennen wir trotzdem wenigstens erkennen, ob der Auftrag eingereicht wurde.

See Also:
  - Constant Field Values

## Method Details

### getErsteZahlung

Date getErsteZahlung() throws RemoteException
Liefert das Datum der ersten Zahlung.

Returns:
  erste Zahlung.
Throws:
  `RemoteException`

### getLetzteZahlung

Date getLetzteZahlung() throws RemoteException
Liefert das Datum der letzten Zahlung oder `null`, wenn kein Zahlungsende definiert ist.

Returns:
  Datum der letzten Zahlung oder `null`.
Throws:
  `RemoteException`

### getNaechsteZahlung

Date getNaechsteZahlung() throws RemoteException
BUGZILLA 204 Liefert das voraussichtliche Datum der naechsten Zahlung. Liegt das Datum der ersten Zahlung in der Zukunft, wird dieses zurueckgeliefert. Liegt das Datum der letzten Zahlung in der Vergangenheit, gilt der Dauerauftrag als abgelaufen und es wird `null` zurueckgeliefert. Andernfalls wird anhand des Zahlungsturnus das naechste Zahl-Datum ermittelt.

Returns:
  Datum der naechsten Zahlung.
Throws:
  `RemoteException`

### getTurnus

Turnus getTurnus() throws RemoteException
Liefert den Zahlungsturnus fuer diesen Dauerauftrag.

Returns:
  Zahlungsturnus des Dauerauftrags.
Throws:
  `RemoteException`

### getOrderID

String getOrderID() throws RemoteException
Liefert die eindeutige ID von der Bank. Damit kann der Dauerauftrag bei Aenderungen wiedererkannt werden.

Returns:
  Order-ID.
Throws:
  `RemoteException`

### setOrderID

void setOrderID(String id) throws RemoteException
Speichert die Order-ID des Dauerauftrages.

Parameters:
  `id` - die Order-ID.
Throws:
  `RemoteException`

### setErsteZahlung

void setErsteZahlung(Date datum) throws RemoteException
Legt das Datum fuer die erste Zahlung fest.

Parameters:
  `datum` - Datum fuer die erste Zahlung.
Throws:
  `RemoteException`

### setLetzteZahlung

void setLetzteZahlung(Date datum) throws RemoteException
Legt das Datum fuer die letzte Zahlung fest.

Parameters:
  `datum` - Datum fuer die letzte Zahlung. Kann `null` sein, wenn kein End-Datum definiert ist.
Throws:
  `RemoteException`

### setTurnus

void setTurnus(Turnus turnus) throws RemoteException
Legt den Zahlungsturnus fest.

Parameters:
  `turnus` - Zahlungsturnus des Dauerauftrags.
Throws:
  `RemoteException`

### isActive

boolean isActive() throws RemoteException
Liefert `true` wenn der Dauerauftrag bei der Bank aktiv ist. Ob dieser nun von der Bank abgerufen oder lokal erstellt und dann eingereicht wurde, spielt keine Rolle. Entscheidend ist lediglich, dass er bei der Bank vorliegt und aktiv ist.

Returns:
  true, wenn der Dauerauftrag bei der Bank aktiv ist.
Throws:
  `RemoteException`

### delete

void delete() throws RemoteException, de.willuhn.util.ApplicationException
Loescht den Dauerauftrag lediglich im lokalen Datenbestand, nicht jedoch bei der Bank. Um den Dauerauftrag online zu loeschen, muss `HBCIDauerauftragDeleteJob` verwendet werden.

Specified by:
  `delete` in interface `de.willuhn.datasource.rmi.Changeable`
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`
See Also:
  - `Changeable.delete()`